Content Delivery Network Interconnection (CDNI) Footprint Types: Country Subdivision Code and Footprint Union
RFC 9388
Nir B. Sopher
Qwilt
6, Ha'harash
Hod HaSharon
4524079
Israel
nir@apache.org
Sanjay Mishra
Verizon
13100 Columbia Pike
Silver Spring
MD
20904
United States of America
sanjay.mishra@verizon.com
July 2023
art
cdni
Open Caching architecture is a use case of Content Delivery Network Interconnection (CDNI) in which the commercial Content Delivery Network (CDN) is the upstream CDN (uCDN) and the ISP caching layer serves as the downstream CDN (dCDN). RFC 8006 defines footprint types that are used for footprint objects as part of the Metadata interface (MI). The footprint types are also used for the Footprint & Capabilities Advertisement interface (FCI) as defined in RFC 8008. This document defines two new footprint types. The first footprint type defined is an ISO 3166-2 country subdivision code. Defining this country subdivision code improves granularity for delegation as compared to the ISO 3166-1 country code footprint type defined in RFC 8006. The ISO 3166-2 country subdivision code is also added as a new entity domain type in the "ALTO Entity Domain Types" registry defined in Section 7.4 of RFC 9241. The second footprint type defines a footprint union to aggregate footprint objects. This allows for additive semantics over the narrowing semantics defined in Appendix B of RFC 8008 and therefore updates RFC 8008. The two new footprint types are based on the requirements raised by Open Caching but are also applicable to CDNI use cases in general.
Introduction
The Streaming Video Technology Alliance [SVTA] is a global association that works to solve streaming video challenges in an effort to improve end-user experience and adoption. The Open Caching Working Group [OCWG] of the SVTA is focused on the delegation of video delivery requests from commercial Content Delivery Networks (CDNs) to a caching layer at the ISP's network. Open Caching architecture is a specific use case of Content Delivery Network Interconnection (CDNI) where the commercial CDN is the upstream CDN (uCDN) and the ISP caching layer is the downstream CDN (dCDN). The "Open Caching Request Routing Functional Specification" defines the Request Routing process and the interfaces that are required for its provisioning. This document defines and registers CDNI Footprint and Capabilities objects [RFC8008] that are required for Open Caching Request Routing.
For consistency with other CDNI documents, this document follows the CDNI convention of using "uCDN" and "dCDN" to represent the commercial CDN and ISP caching layer, respectively.
This document registers two CDNI Metadata footprint types (Section 7.2 of [RFC8006]) for the defined objects:
- Country subdivision code footprint type (e.g., for a dCDN advertising a footprint that is specific to a state in the United States of America)
- Footprint union footprint type (for a dCDN advertising a footprint that consists of a group built from multiple footprint types, e.g., both IPv4 and IPv6 client subnets)
Terminology
The following terms are used throughout this document:
CDN:
Content Delivery Network
Additionally, this document reuses the terminology defined in [RFC6707], [RFC7336], [RFC8006], and [RFC8008]. Specifically, we use the following CDNI abbreviations:
uCDN:
upstream CDN (see [RFC7336])
dCDN:
downstream CDN (see [RFC7336])
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
CDNI Metadata Additional Footprint Types
Section 5 of [RFC8008] describes the Footprint & Capabilities Advertisement interface (FCI) Capability Advertisement object, which includes an array of CDNI footprint objects. Each such object has a footprint type and a footprint value, as described in Section 4.2.2.2 of [RFC8006]. This document defines additional footprint types, beyond those mentioned in [RFC8006].
CDNI Metadata "subdivisioncode" Footprint Type
Section 4.3.8 of [RFC8006] specifies the "countrycode" footprint type for listing [ISO3166-1] alpha-2 codes. Using footprint objects of this type, one can define an FCI Capability Advertisement object footprint constraint that matches a specific country. This document defines the "subdivisioncode" simple data type as well as a footprint type, allowing the dCDN to define constraints that match geographic areas with better granularity, specifically using the [ISO3166-2] country subdivision codes.
CDNI Metadata "subdivisioncode" Data Type
The "subdivisioncode" data type specified in Section 2.1.1.1 describes a country-specific subdivision using a code as defined in [ISO3166-2]. The data type is added to the list of data types described in Section 4.3 of [RFC8006] that are used as properties of CDNI Metadata objects.
CDNI Metadata "subdivisioncode" Data Type Description
An [ISO3166-2] code in lowercase. Each code consists of two parts separated by a hyphen. As per [ISO3166-2], the first part is the [ISO3166-1] code of the country and the second part is a string of up to three alphanumeric characters.
Type:
String
Example country subdivision codes:
- "ca-on"
- "us-ny"
CDNI Metadata "subdivisioncode" Footprint Type Description
The "subdivisioncode" simple data type specified in Section 2.1.1 is added to the data types listed as footprint types in Section 4.2.2.2 of [RFC8006].
Figure 1 is an example using a footprint object of type "subdivisioncode". The footprint object in this example creates a constraint that matches clients in the state of either New Jersey or New York, USA (ISO [ISO3166-2] codes "US-NJ" and "US-NY", respectively).
Illustration of Country Subdivision Code Footprint Advertisement

{
  "capabilities": [
    {
      "capability-type": <CDNI capability object type>,
      "capability-value": <CDNI capability object>,
      "footprints": [
          {
              "footprint-type": "subdivisioncode",
              "footprint-value": ["us-nj", "us-ny"]
          }
      ]
    }
  ]
}

CDNI Metadata "footprintunion" Footprint Type
As described in Section 5 of [RFC8008], the FCI Capability Advertisement object includes an array of CDNI footprint objects. Appendix B of [RFC8008] specifies the semantics for Footprint Advertisement such that multiple footprint constraints are additive. This implies that the advertisement of different footprint types narrows the dCDN's candidacy cumulatively.
Sections 4.3.5 and 4.3.6 of [RFC8006] specify the "ipv4cidr" and the "ipv6cidr" footprint types, respectively, for listing IP unscoped address blocks. Using footprint objects of these types, one can define FCI Capability Advertisement object footprint constraints that match either IPv4 or IPv6 clients, but not both. This is due to the described "narrowing" semantic of the Footprint Objects array, as described in Appendix B of [RFC8008], that prevents the usage of these objects together to create a footprint constraint that matches IPv4 clients with IPv6 clients.
Figure 2 is an example attempting to create an object that matches IPv4 clients of subnet "192.0.2.0/24" as well as IPv6 clients of subnet "2001:db8::/32". Such a definition results in an empty list of clients, as the constraints are additives and a client address cannot be both IPv4 and IPv6.
Example of Narrowing Semantic Illustrating Advertisement of a Null Footprint

{
  "capabilities": [
    {
      "capability-type": <CDNI capability object type>,
      "capability-value": <CDNI capability object>,
      "footprints": [
          {
              "footprint-type": "ipv4cidr",
              "footprint-value": ["192.0.2.0/24"]
          },
          {
              "footprint-type": "ipv6cidr",
              "footprint-value": ["2001:db8::/32"]
          }
      ]
    }
  ]
}

To overcome the described limitation and allow a list of footprint constraints that match both IPv4 and IPv6 client subnets, this document defines the "footprintunion" footprint type. This footprint type allows the collection of multiple footprint-objects into a unified object. Therefore, it resolves the above limitation and can be particularly applicable to unify semantically related objects: for example, an IPv4 CIDR together with an IPv6 CIDR or a country code together with a country subdivision code.
Note: to avoid implementation complexity, a "footprintunion" MUST NOT list any "footprintunion" as a value. As a union of unions is simply a union, this syntactic restriction does not result with any semantic limitation.
CDNI Metadata "footprintunion" Data Type
The "footprintunion" data type is based on the footprint object already defined in Section 4.2.2.2 of [RFC8006]. The footprint value for a "footprintunion" object is an array of footprint objects, where the footprint objects MUST be of any footprint type other than "footprintunion".
CDNI Metadata "footprintunion" Footprint Type Description
The "footprintunion" data type specified in Section 2.2.1 is added to the data types listed as footprint types in Section 4.2.2.2 of [RFC8006].
Figure 3 is an example using a footprint union combining both IPv4 and IPv6 client subnets.
Example of an Advertisement of Footprint Union for Multiple Classless Inter-Domain Routing (CIDR) Footprint Types

{
  "capabilities": [
    {
      "capability-type": <CDNI capability object type>,
      "capability-value": <CDNI capability object>,
      "footprints": [
        {
          "footprint-type": "footprintunion",
          "footprint-value": [
            {
              "footprint-type": "ipv4cidr",
              "footprint-value": ["192.0.2.0/24"]
            },
            {
              "footprint-type": "ipv6cidr",
              "footprint-value": ["2001:db8::/32"]
            }
          ]
        }
      ]
    }
  ]
}

The footprint union also enables composing of footprint objects based on the country code and country subdivision code. In Figure 4, we create a constraint covering autonomous system 64496 within the USA (ISO alpha-2 code "US" as described in [ISO3166-1]) and the Ontario province of Canada (ISO code "CA-ON" as described in [ISO3166-2]).
Example of an Advertisement of Footprint Union for Multiple Geographical Footprint Types

{
  "capabilities": [
    {
      "capability-type": <CDNI capability object type>,
      "capability-value": <CDNI capability object>,
      "footprints": [
        {
          "footprint-type": "asn",
          "footprint-value": ["as64496"]
        },
        {
          "footprint-type": "footprintunion",
          "footprint-value": [
            {
              "footprint-type": "countrycode",
              "footprint-value": ["us"]
            },
            {
              "footprint-type": "subdivisioncode",
              "footprint-value": ["ca-on"]
            }
          ]
        }
      ]
    }
  ]
}

ALTO Property Map Service Entity
Section 6 of [RFC9241] describes how to represent footprint objects as entities in the ALTO property map. The approach is to represent the footprint type as an entity domain type of the ALTO entity and the footprint value as its domain-specific identifier. [RFC9241] further refers to the representation of footprint objects of types "asn" and "countrycode". Here, we extend this definition to the "subdivisioncode" footprint type.
SUBDIVISIONCODE Domain
The SUBDIVISIONCODE domain associates property values that define codes for the names of the principal subdivisions.
Entity Domain Type
The entity domain type of the SUBDIVISIONCODE domain is "subdivisioncode" (in lowercase).
Domain-Specific Entity Identifiers
The entity identifier of an entity in a SUBDIVISIONCODE is encoded as an alpha-2 [ISO3166-1] country code, followed by a separator and up to three alphanumeric characters.
Hierarchy and Inheritance
There is no hierarchy or inheritance for properties associated with country subdivision codes.
IANA Considerations
CDNI Metadata Footprint Types
Section 7.2 of [RFC8006] specifies the "CDNI Metadata Footprint Types" subregistry within the "Content Delivery Network Interconnection (CDNI) Parameters" registry.
This document registers two footprint types in that subregistry as defined in Sections 2.1 and 2.2:
Additions to the CDNI Metadata Footprint Types Subregistry
Footprint Type | Description | Reference
subdivisioncode | ISO 3166-2 country subdivision code: alpha-2 country code, followed by a hyphen-minus and up to 3 characters from A-Z;0-9 as a code within the country | RFC 9388
footprintunion | A combination of other footprint objects | RFC 9388
ALTO Entity Domain Types
Section 12.3 of [RFC9240] creates the "ALTO Entity Domain Types" subregistry within the "Application-Layer Traffic Optimization (ALTO) Protocol" registry.
This document registers an additional ALTO Entity Domain Type within that subregistry:
Addition to the ALTO Entity Domain Types Subregistry
Identifier | Entity Identifier Encoding | Hierarchy and Inheritance | Media Type of Defining Resource | Mapping to ALTO Address Type
subdivisioncode | See RFC 9388, Section 3.1.2 | None | None | false
Security Considerations
This specification is in accordance with "[RFC8006]" and "[RFC8008]". As such, it is subject to the security and confidentiality considerations as defined in Section 8 of [RFC8006] and in Section 7 of [RFC8008], respectively.
References
Normative References
[ISO3166-1]

Codes for the representation of names of countries and their subdivisions -- Part 1: Country code
ISO
2020-08
ISO 3166-1:2020
Edition 4
[ISO3166-2]

Codes for the representation of names of countries and their subdivisions -- Part 2: Country subdivision code
ISO
2020-08
ISO 3166-2:2020
Edition 4
Informative References
[SVTA]

Streaming Video Technology Alliance
SVTA
[OCWG]

Open Caching
SVTA
[OC-RR]

Open Caching - Request Routing Functional Specification
Ori Finkelman, Ed.
Qwilt
Bill Zurat
Disney Streaming Services
Dan Sahar
Qwilt
Eric Klein
SiriusXM
Jason Hofmann
Limelight Networks
Kevin J. Ma
Ericsson
Matt Stock
Viasat
Sanjay Mishra
Verizon
Yoav Gressel
Qwilt
15 January 2021
Version 2.0
[RFC8008]
[RFC8006]
[RFC6707]
[RFC7336]
[RFC2119]
[RFC8174]
[RFC9241]
[RFC9240]
Acknowledgements
The authors would like to express their gratitude to Ori Finkelman and Kevin J. Ma for their guidance and reviews throughout the development of this document. We would also like to thank all the Area Directors for their review and feedback in improving this document.